/**
 * Copyright &copy; 2021-2026 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.sys.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.core.domain.TreeMapper;
import com.jeeplus.sys.domain.Office;
import com.jeeplus.sys.domain.SysParameter;
import com.jeeplus.sys.domain.SysParameterValue;
import com.jeeplus.sys.service.dto.OfficeDTO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 机构MAPPER接口
 *
 * @author jeeplus
 * @version 2021-05-16
 */
public interface OfficeMapper extends TreeMapper<Office> {

    OfficeDTO getOfficeByName(@Param("officeName") String officeName, @Param("parentName") String parentName);

    /**
     * 根据id查询office信息
     * @param id
     * @return
     */
    OfficeDTO getOfficeById(String id);
    /**
     * 根据部门名称 查询部门及所有子部门信息
     * @param officeName
     * @return
     */
    List<OfficeDTO> getOfficeAllByOfficeName(@Param("officeName") String officeName);

    SysParameter findIsforce(@Param("parameter")String parameter);

    SysParameterValue findValueByParameter(@Param("parameter")String parameter, @Param("branchOffice")String branchOffice);

    SysParameterValue findSysValue(String parameter);

    IPage<OfficeDTO> findList(Page<OfficeDTO> page, @Param(Constants.WRAPPER) QueryWrapper<OfficeDTO> queryWrapper);

    List<String> getOfficeNameByIds(List<String> idList);

    List<String> getOfficeIdByNames(List<String> nameList);

    /**
     * 获取二级节点数据信息
     * @return
     */
    List<OfficeDTO> getSecondLevelData();

}
